(function (MO) {
    $$$.extend(MO, {
        opCode: function () {
            return $$$.toDateStr('HHmmssmsec') - 0
        },
        popup: function (type, msg, duration) {
            uexWindow.toast(type, '5', msg, duration)
        },
        alert: function (title, msg, btn) {
            uexWindow.alert(title, msg, btn)
        },
        confirm: function (title, msg, btns, handler) {
            uexWindow.cbConfirm = function (opId, dataType, data) {
                handler((data - 0))
            };
            uexWindow.confirm(title, msg, btns)
        },
        openPage: function (name, dir) {
            var dir = dir || '';
            uexWindow.open(name, '0', dir + name + ".html" , '2', '', '', 0x0)
        },
        interceptBack: function (cb) {
            if (this.browsorType() == "1") {
                uexWindow.onKeyPressed = function (keycode) {
                    if (cb) cb(keycode)
                };
                uexWindow.setReportKey('0', '1')
            }
        },
        openContact: function (cb) {
            uexContact.cbOpen = function (opId, dataType, data) {
                if (dataType == 1) {
                    var contact = JSON.parse(data);
                    cb(contact)
                }
            };
            uexContact.open()
        },
        close: function () {
            // alert($$$.storage(MO.Config.OpLoadFinish) != "1");
            // alert(!$$$.storage(MO.Config.OpLoadFinish));
            if($$$.storage(MO.Config.OpLoadFinish) != "1"){
                uexWindow.close('-1');
            }
            else{
                uexWindow.closePopover('dd');
                $$$.storage(MO.Config.OpLoadFinish,0);
            }
        },
        execScript: function (page, script, execType) {
            if (!execType) uexWindow.evaluatePopoverScript(page, "content", script);
            else uexWindow.evaluateScript(page, execType, script)
        },
        zy_for: function (sender, id) {
            var chx = $$$(id);
            if (chx.type == "checkbox") chx.checked = !chx.checked;
            if (chx.type == "radio" && !chx.checked) chx.checked = "checked"
        },
        formatHtml: function (html) {
            html = $$$.trim(html);
            html = html.replace(/"/g, '%2522');
            html = html.replace(/</g, '%253C');
            html = html.replace(/>/g, '%253E');
            return html
        },
        formatReceivers: function (receiverType, receivers) {
            return (receivers.length == 1) ? receivers : ((receivers.length > 2) ? (receivers[0] + "、" + receivers[1] + "等" + receivers.length + "个" + receiverType) : (receivers[0] + "、" + receivers[1] + "两个" + receiverType))
        },
        getRandom: function (len) {
            var ranLen = len || 6,
                index = 0,
                ranChars = "",
                seek, oChars = "01234567890abcdefghijklmnopqrstuvwxyz01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            while (index < ranLen) {
                seek = window.Math.round(window.Math.random() * 100);
                if (seek < 82) ranChars += oChars.charAt(seek);
                else continue;
                index++
            };
            return ranChars
        },
        userId: function (userId) {
            if ($$$.isDefine(userId)) $$$.storage(MO.Key.UserId, userId);
            else return $$$.storage(MO.Key.UserId)
        },
        userName: function (userName) {
            if ($$$.isDefine(userName)) $$$.storage(MO.Key.UserName, userName);
            else return $$$.storage(MO.Key.UserName)
        },
        unitId: function (unitId) {
            if ($$$.isDefine(unitId)) $$$.storage(MO.Key.UnitId, unitId);
            else return $$$.storage(MO.Key.UnitId)
        },
        unitName: function (unitName) {
            if ($$$.isDefine(unitName)) $$$.storage(MO.Key.UnitName, unitName);
            else return $$$.storage(MO.Key.UnitName)
        },
        unitStaff: function (unitStaff) {
            if ($$$.isDefine(unitStaff)) $$$.storage(MO.Key.UnitStaff, unitStaff);
            else return $$$.storage(MO.Key.UnitStaff)
        },
        empStaff: function (empStaff) {
            if (empStaff != null) $$$.storage(MO.Key.EmpStaff, empStaff);
            else return $$$.storage(MO.Key.EmpStaff)
        },
        cusStaff: function (cusStaff) {
            if (cusStaff != null) $$$.storage(MO.Key.CusStaff, cusStaff);
            else return $$$.storage(MO.Key.CusStaff)
        },
        browsorType: function (bt) {
            if (bt != null) $$$.storage(MO.Key.BrowsorType, bt);
            else return $$$.storage(MO.Key.BrowsorType)
        },
        openByBrowsor: function (url) {
            console.log(url);
            console.log(this.browsorType());
            console.log(uexWidget.loadApp);
            switch (this.browsorType() - 0) {
            case 0:
                uexWidget.loadApp(url, "", "");
                break;
            case 1:
                //uexWidget.loadApp("android.intent.action.VIEW", "text/html", url);
                //uexWidget.startApp("1", "android.intent.action.VIEW", '{"data":{"mimeType":"text\/html","scheme":"' + url + '"}}');
                //uexWidget.startApp("1", "android.intent.action.VIEW", '{"data":{"mimeType":"text/html","scheme":"http://www.baidu.com"}}');
                
                //uexWidget.startApp(1, "android.intent.action.VIEW",'{"data":{"mimeType":"text/html","scheme":"http://www.baidu.com"}}');
                //uexWidget.startApp(0, "com.UCMobile","com.UCMobile.main.UCMobile");
                //uexWidget.startApp(0, "com.UCMobile","","",'{"data":{"mimeType":"text/html","scheme":"ucbrowser:http://www.baidu.com"}}');
                
                
                //uexWidget.loadApp('android.intent.action.VIEW','text/html',url);
                
                
                 //alert(uexWidget.open);
               
                //uexWidget.startApp(0, "com.UCMobile","","",'{"data":{"mimeType":"text/html","scheme":"ucbrowser:http://www.baidu.com"}}');
                
                
                // try{
                    // MO.Config.OpLoadFinish = true;
                    uexWindow.openPopover('dd', 0, url, '',0,0, '', '','', 128);
                    
                    
                    //uexWindow.open(name,0,url,0,'','',128); 
                    //alert(uexWindow.getState());
                        
                // }
                // catch(e){
                    // alert(e);
                // }
               
                           // uexWidget.cbStartApp = function(info){
                                // alert(info);
                            // }  
//                 
                
                //var optInfo = "";
                //var extra='{data:"ucbrowser://http://www.appcan.cn/"}';
                //uexWidget.startApp(0, "com.UCMobile","com.UCMobile.main.UCMobile",optInfo,extra);
                
                    // var optInfo = "{'key1':'value1'},{'key2':'value1'}";
                    // var extra='{data:"http://www.appcan.cn/"}';
                    // uexWidget.startApp(0, "com.tencent.mtt","com.tencent.mtt.MainActivity",optInfo,extra);
                
                
                // var packageName = "com.UCMobile";
                // var className = "com.UCMobile.main.UCMobile";
                // var optInfo = "{'key1':'value1'},{'key2':'value1'}";
                // var extra = '{data:"http://www.baidu.com"}';
                // try {
                   // uexWidget.startApp(0, packageName, className, optInfo, extra);
                // } catch(e) {
                   // alert(e);
                // }
                 break;
            }
        }
    });
    $$$.extend(MO, {
        formatRequest: function (ajax) {
            return '<req cmd="' + ajax.Cmd + '" sub="' + ajax.SubCmd + '"><msg ver="' + ajax.ApiVer + '">' + ajax.Paras + '</msg></req>'
        },
        error: function (err) {
            var dir = MO.Config.DirDepth == 1 ? "../" : "";
            uexWindow.closeToast();
            switch (err) {
            case "1":
            case "2":
                $$$.clear();
                MO.popup('0', (err == '1' ? '您没有访问权限' : '您今天的登录次数已超过限制，请明天再登录！'), 2000);
                MO.openPage('login', dir);
                break;
            case "3":
            case "4":
                MO.alert('提示', '您的客户端版本过老，此功能无法使用。请检查更新！', '确定');
                MO.openPage("psetup", dir + 'setup/');
                break;
            case "5":
                MO.popup('0', "数据加载出错了....", 2000);
                break;
            case "6":
            case "7":
                MO.popup('0', (err == '6' ? '用户登录超时，请重新登录' : '没有单位访问权限'), 2000);
                MO.openPage('login', dir);
                break;
            default:
                MO.popup('0', err, 3000);
                break
            }
        },
        getJSON: function (service, success, error) {
            uexXmlHttpMgr.onData = function (opId, status, data) {
                if ((status - 0) == 1) {
                    uexXmlHttpMgr.close(opId);
                    uexWindow.closeToast();
                    if ($$$.isDefine(data)) {
                        if (data.length == 1) MO.error(data);
                        else {
                            data = JSON.parse(data);
                            if ($$$.isDefine(data.err)) {
                                MO.error(data.err);
                                if (error) error()
                            } else success(data)
                        }
                    } else MO.popup('0', '程序出现异常', 2000)
                } else MO.popup('0', MO.Config.Tip, 1000)
            };
            MO.popup('1', MO.Config.Tip, 0);
            var opCode = MO.opCode();
            uexXmlHttpMgr.open(opCode, "POST", ($$$.isDefine(service.Api) ? service.Api : (MO.Config.MainApi + '?t=' + $$$.storage(MO.Key.Token))), "");
            uexXmlHttpMgr.setPostData(opCode, "0", "xml", this.formatRequest(service));
            uexXmlHttpMgr.send(opCode)
        }
    })
})(window.MO)