(function (window) {
    var MO = {
        Config: {
            RootApi: 'http://api.wobangong.com/api1/',
            FindPwdUrl: "http://www.wobangong.com/help/m_findpwd.aspx",
            IsAppStore: "0",
            ProductName: "沃办公",
            ClientVer: '1109',
            DirDepth: 0,
            OpLoadFinish:0,
            Tip: '数据加载中...'
        },
        Key: {
            Token: "MoToken",
            LoginInfo: "MoLoginInfo",
            IsAutoLogin: "MoIsAutoLogin",
            DeviceInfo: "MoDeviceInfo",
            ImgDisplayType: "MoImgDisplayType",
            LastVersion: "MoLastVersion",
            UserId: "MoUserId",
            UserName: "MoUserName",
            SmsUserType: "MoSmsUserType",
            UnitId: "MoUnitId",
            UnitName: "MoUnitName",
            UnitStaff: "MoUnitStaff",
            EmpStaff: "MoEmpStaff",
            CusStaff: "MoCusStaff",
            SendSmsType: "MoSendSmsType",
            SendSmsIdList: "MoSendSmsIdList",
            SendSmsRevSummary: "MoSendSmsRevSummary",
            FriendGroupId: "MoFriendGroupId",
            FriendGroupName: "MoFriendGroupName",
            FriendId: "MoFriendId",
            FriendName: "MoFriendName",
            FoundFriendId: "MoFoundFriendId",
            FoundFriendInfo: "MoFoundFriendInfo",
            OutboxType: "MoOutboxType",
            SmsId: "MoSmsId",
            TimingSmsInfo: "MoTimingSmsInfo",
            TimingSmsCont: "MoTimingSmsCont",
            UserIdToReply: "MoUserIdToReply",
            UserNameToReply: "MoUserNameToReply",
            UnitAddbookGroupId: "MOUnitAddbookGroupId",
            UnitAddbookGroupName: "MoUnitAddbookGroupName",
            ContactId: "MoContactId",
            ContactName: "MoContactName",
            SelectedDeptId: "MoSelectedDeptId",
            SelectedDeptName: "MoSelectedDeptName",
            CusAddbookGroupId: "MoCusAddbookGroupId",
            CusAddbookGroupName: "MoCusAddbookGroupName",
            CustomerId: "MoCustomerId",
            CustomerName: "MoCustomerName",
            SelectedGroupId: "MoSelectedGroupId",
            SelectedGroupName: "MoSelectedGroupName",
            NoticeGroupId: "MoNoticeGroupId",
            NoticeId: "MoNoticeId",
            NoticeGroupName: "MoNoticeGroupName",
            NoticeCommentNum: "MoNoticeCommentNum",
            NoticeInfo: "MoNoticeInfo",
            BoardId: "MoBoardId",
            BoardName: "MoBoardName",
            TopicType: "MoTopicType",
            TopicId: "MoTopicId",
            TopicClass: "MoTopicClass",
            TopicCommentId: "MoTopicCommentId",
            TopicCommentCont: "MoTopicCommentCont",
            TopicTitle: "MoTopicTitle",
            TopicCont: "MoTopicCont",
            BrowsorType: "MoBrowsorType",
            FlowType: "MoFlowType",
            DocGroupId: "MoDocGroupId",
            DocGroupName: "MoDocGroupName",
            DefaultDesktop: "MoDefaultDesktop",
            CircleInfo: 'MoCircleInfo',
            CircleMemberId: "MoCircleMemberId",
            CircleMemberName: "MoCircleMemberName",
            ColleagueId: "MoColleagueId",
            ColleagueName: "MoColleagueName"
        }
    };
    $$$.extend(MO.Config, {
        MainApi: MO.Config.RootApi + 'api.ashx',
        LoginApi: MO.Config.RootApi + 'login.ashx',
        CheckUpdateApi: MO.Config.RootApi + 'upgrade.ashx'
    });
    $$$.extend(MO, {
        Service: {
            Login: {
                Cmd: 'login',
                SubCmd: 'login',
                Api: MO.Config.LoginApi,
                ApiVer: 1
            },
            Logout: {
                Cmd: 'login',
                SubCmd: 'logout',
                Api: MO.Config.LoginApi,
                ApiVer: 1,
                Paras: ''
            },
            GetUnits: {
                Cmd: 'user',
                SubCmd: 'getUnit',
                ApiVer: 1,
                Paras: ''
            },
            GetUnitAddGroup: {
                Cmd: 'unit',
                SubCmd: 'getGroup',
                ApiVer: 1
            },
            GetBoard: {
                Cmd: 'bbs',
                SubCmd: 'getBoard',
                ApiVer: 1
            },
            CommentTopic: {
                Cmd: 'bbs',
                SubCmd: 'comment',
                ApiVer: 1
            },
            GetTopicComment: {
                Cmd: 'bbs',
                SubCmd: 'getComment2',
                ApiVer: 1
            },
            GetNoticeComment: {
                Cmd: 'notice',
                SubCmd: 'getComment',
                ApiVer: 1
            },
            GetMemberInfo: {
                Cmd: 'unit',
                SubCmd: 'memberInfo',
                ApiVer: 1
            },
            SendSms: {
                Cmd: 'sms',
                SubCmd: 'sendSms',
                ApiVer: 1
            },
            GetMembers: {
                Cmd: 'unit',
                SubCmd: 'getMember',
                ApiVer: 1
            },
            FindMembers: {
                Cmd: 'unit',
                SubCmd: 'findMember',
                ApiVer: 1
            },
            GetColleagueInfo: {
                Cmd: 'unit',
                SubCmd: 'colleagueInfo',
                ApiVer: 1
            },
            AddMember: {
                Cmd: 'unit',
                SubCmd: 'addMember',
                ApiVer: 1
            },
            GetMemberGroup: {
                Cmd: 'unit',
                SubCmd: 'getGroup',
                ApiVer: 1
            },
            GetNoticeGroup: {
                Cmd: 'notice',
                SubCmd: 'getGroup',
                ApiVer: 1
            },
            GetNoticeList: {
                Cmd: 'notice',
                SubCmd: 'getNoticeList',
                ApiVer: 1
            },
            CommentNotice: {
                Cmd: 'notice',
                SubCmd: 'comment',
                ApiVer: 1
            },
            GetNotice: {
                Cmd: 'notice',
                SubCmd: 'getNotice',
                ApiVer: 1
            },
            PublicTopic: {
                Cmd: 'bbs',
                SubCmd: 'topic',
                ApiVer: 1
            },
            GetTopicClass: {
                Cmd: 'bbs',
                SubCmd: 'getTopicClass',
                ApiVer: 1
            },
            GetInboxSms: {
                Cmd: 'sms',
                SubCmd: 'smsInbox',
                ApiVer: 2
            },
            GetOutboxSms: {
                Cmd: 'sms',
                SubCmd: 'smsOutbox',
                ApiVer: 2
            },
            GetTimingSms: {
                Cmd: 'sms',
                SubCmd: 'smsTiming',
                ApiVer: 2
            },
            GetTopicList: {
                Cmd: 'bbs',
                SubCmd: 'getTopicList',
                ApiVer: 1
            },
            GetTopic: {
                Cmd: 'bbs',
                SubCmd: 'getTopic',
                ApiVer: 1
            },
            GetTopicReply: {
                Cmd: 'bbs',
                SubCmd: 'getComment',
                ApiVer: 1
            },
            GetUnitInfo: {
                Cmd: 'unit',
                SubCmd: 'unitInfo',
                ApiVer: 1
            },
            GetFriendGroup: {
                Cmd: 'friend',
                SubCmd: 'getGroup',
                ApiVer: 1,
                Paras: '<info total="1"/>'
            },
            GetFriends: {
                Cmd: 'friend',
                SubCmd: 'getFriend',
                ApiVer: 1
            },
            GetFriend: {
                Cmd: 'friend',
                SubCmd: 'friendInfo',
                ApiVer: 1
            },
            FindFriend: {
                Cmd: 'friend',
                SubCmd: 'findFriend',
                ApiVer: 1
            },
            AddFriend: {
                Cmd: 'friend',
                SubCmd: 'addFriend',
                ApiVer: 1
            },
            GetSmsRevList: {
                Cmd: 'sms',
                SubCmd: 'smsRevList',
                ApiVer: 1
            },
            HandleTimingSms: {
                Cmd: 'sms',
                SubCmd: 'setTiming',
                ApiVer: 1
            },
            GetFlowList: {
                Cmd: 'flow',
                SubCmd: 'docList',
                ApiVer: 1
            },
            GotoWeb: {
                Cmd: 'user',
                SubCmd: 'loginWeb',
                ApiVer: 1,
                Paras: ''
            },
            GetFlowUrl: {
                Cmd: 'flow',
                SubCmd: 'docUrl',
                ApiVer: 1
            },
            GetNewFlowUrl: {
                Cmd: 'flow',
                SubCmd: 'newDocUrl',
                ApiVer: 1
            },
            GetNoticeUrl: {
                Cmd: 'notice',
                SubCmd: 'getNoticeUrl',
                ApiVer: 1
            },
            GetDocGroup: {
                Cmd: 'doc',
                SubCmd: 'getGroup',
                ApiVer: 1
            },
            GetDocList: {
                Cmd: 'doc',
                SubCmd: 'docList',
                ApiVer: 1
            },
            GetDocUrl: {
                Cmd: 'doc',
                SubCmd: 'docUrl',
                ApiVer: 1
            },
            GetCircleList: {
                Cmd: 'quan',
                SubCmd: 'getQuan',
                ApiVer: 1
            },
            GetCircleMemberList: {
                Cmd: 'quan',
                SubCmd: 'getMember',
                ApiVer: 1
            },
            GetMemberDetails: {
                Cmd: 'quan',
                SubCmd: 'memberInfo',
                ApiVer: 1
            },
            GetCircleNoticeInfo: {
                Cmd: 'quan',
                SubCmd: 'getNotice',
                ApiVer: 1
            },
            DeleteCircleMember: {
                Cmd: 'quan',
                SubCmd: 'delMember',
                ApiVer: 1
            },
            AddCircleMember: {
                Cmd: 'quan',
                SubCmd: 'addMember',
                ApiVer: 1
            },
            GetCircleLog: {
                Cmd: 'quan',
                SubCmd: 'getRecord',
                ApiVer: 1
            }
        }
    });
    window.MO = MO
})(window)